#ifndef _UTILS_H
#define _UTILS_H

#ifdef WIN32
	#include <Windows.h>
#endif

#include "types.h"

enum media_type{unknown, removable, fixed};

struct drive_info
{
	drive_info()
		:_cylinder(0)
		,_type(fixed)
		,_tracks_per_cylinder(0)
		,_sectors_per_track(0)
		,_bytes_per_sector(0)
		,_lba_size(0)
	{
	}

	void operator= (drive_info di)
	{
		_type = di._type;
		_bytes_per_sector = di._bytes_per_sector;
		_lba_size = di._lba_size;
		_cylinder = di._cylinder;
		_sectors_per_track = di._sectors_per_track;
		_tracks_per_cylinder = di._tracks_per_cylinder;
	}


	u_longlong _cylinder;
	media_type _type;
	u_long _tracks_per_cylinder;
	u_long _sectors_per_track;
	u_long _bytes_per_sector;
	u_longlong _lba_size;
};


bool get_drive_info(HANDLE _handle, drive_info &drive_info_);
void store_drive_geometry(drive_info &di);

#endif //_UTILS_H