// BackupMBR.cpp : Defines the entry point for the console application.
//


#ifdef WIN32
    #include <Windows.h>
#elif __linux__
    #include <sys/types.h>
    #include <sys/stat.h>
    #include <fcntl.h>
    #include "unistd.h"
#else
    ERROR: unknown OS
#endif

#include <iostream>
#include <iomanip>
#include <vector>
#include <fstream>

#include "types.h"
#include "Utils.h"
#include "file_io.h"




#define     MBR_SIZE                                  0x200
#define     FILE_ATTRIBUTE_NORMAL   0644


#ifdef WIN32
    // nothing to do
#elif __linux__
    #define GENERIC_READ  					O_RDONLY
    #define GENERIC_WRITE 					O_WRONLY
    #define CREATE_ALWAYS					O_CREAT
    #define OPEN_EXISTING                                       0
#endif

using namespace std;

int main(int argc, char* argv[])
{

	//open physical drive
        HANDLE handle_r = create_io_file("/dev/sda",
								    GENERIC_READ,
									OPEN_EXISTING,
									FILE_ATTRIBUTE_NORMAL);

	if(handle_r == INVALID_HANDLE_VALUE)
	{
		cout<<"Can't open file";
		return 0;
	}


	u_char buffer[MBR_SIZE];

	// get mbr
	u_long result_ = read_io_file(handle_r, buffer, MBR_SIZE);
	if (result_ == -1)
	{
		close_io_file(handle_r);
		cout<<"Can't read source file";
		return 0;
	}

	// dump mbr to mbr_backup
	HANDLE handle_w = create_io_file("mbr_backup"
		, GENERIC_WRITE 
		, CREATE_ALWAYS 
		, FILE_ATTRIBUTE_NORMAL);

	if(handle_w == INVALID_HANDLE_VALUE)
	{
		cout<<"Can't open file";
		return 0;
	}

	result_ = write_io_file(handle_w, buffer, MBR_SIZE);
	if (result_ == -1)
	{
		close_io_file(handle_r);
		cout<<"Can't write dump file";
		return 0;
	}


	//get drive info

	drive_info drive_info_;
	if(get_drive_info(handle_r, drive_info_))
	{
		//store disk geometry
		store_drive_geometry(drive_info_);
	}

	// close handles
	close_io_file(handle_r);
	close_io_file(handle_w);

	return 0;
}
